/*
$Header: /home/koba/pilot/PilotGoJ/src/RCS/pigoty.h,v 1.3 2000/03/10 12:17:30 koba Exp $
*/
/*------------------------------
  pigoTY.h -- Pilot GO common header file
------------------------------*/
#include "proto.h"

/* definitions */

#define EMPTY 0
#define WHITE 1
#define BLACK 2
//#define HINT  3

#define	HUMAN 0
#define	PALM  1

#define ENDGAME     0
#define PLAY        1
//#define HANDICAP    2
#define REMOVEDEAD  3
#define FILLNEUTRAL 4

#define TRUE  1
#define FALSE 0

#define PilotGoAppID    CREATERID
#define PilotGoDBType   'DATA'   // 0x64415441 in hexadecimal

#define	ENGLISH	0
#define	JAPANESE	1

#define	UNDOMAX	4

#define MAX(x,y)        ((x>y) ? x : y)
#define MIN(x,y)        ((x>y) ? y : x)

#define	fioe(i,j)	check_eye(i,j,game.mymove)
#define	FIOE

/* public types */
//	PREFVERSION == 2
typedef struct {
	int	Version;
	int	Size;

	unsigned char	BoardSizeDefault;
	unsigned char	UndoDefault;
	unsigned char	KomiDefault;
	unsigned char	RulePassDefault;
	unsigned char	RuleScoreDefault;
	unsigned char	RuleSekiDefault;
	unsigned char	RuleHandicapDefault;
	unsigned char	RuleSuicideDefault;

	unsigned char p[19][19];
	unsigned char l[19][19];
	unsigned char ng[19][19];
	unsigned char undo[19][19];
	int mymove,umove;
	int lib;
	int play;	/*	status of play	*/
	int pass;	/*	number of pass	*/
	int opn[9];
	int mk; 	/*	computer's killed pieces	*/
	int uk;		/*	human's killed pieces		*/
	int mik, mjk;	/*	computer's lask killed posission	*/
	int uik, ujk;	/*	human's last killed posission 		*/
	int BoardSize, offset, width, handicap;
	int lastX,lastY;/*	lastX, lastY	*/
	int fill;
	int mycount;
	int undocnt;
	int lastX_undo[UNDOMAX];
	int lastY_undo[UNDOMAX];
	int mk_undo[UNDOMAX];
	int uk_undo[UNDOMAX];
	int mik_undo[UNDOMAX];
	int mjk_undo[UNDOMAX];
	int uik_undo[UNDOMAX];
	int ujk_undo[UNDOMAX];
	unsigned char	Komi;
	unsigned char	RulePass;
	unsigned char	RuleUndo;
	unsigned char	RuleSeki;
	unsigned char	RuleHandicap;
	unsigned char	RuleSuicide;
	unsigned char	BlackWhite;
	unsigned char	UndoCount;
} GAME , OLD_GAME;




//	PREFVERSION==1
/*
typedef struct {
	int	Version;
	int	Size;

	unsigned char	BoardSizeDefault;
	unsigned char	UndoDefault;
	unsigned char	KomiDefault;
	unsigned char	RulePassDefault;
	unsigned char	RuleScoreDefault;
	unsigned char	RuleSekiDefault;
	unsigned char	RuleHandicapDefault;
	unsigned char	RuleSuicideDefault;

	unsigned char p[19][19];
	unsigned char l[19][19];
	unsigned char ng[19][19];
	int mymove,umove;
	int lib;
	int play;
	int pass;
	int mk,uk;
	int opn[9];
	int mik, mjk;
	int uik, ujk;
	int BoardSize, offset, width, handicap;
	int lastX,lastY;
	int fill;
	int mycount;
	unsigned char	Undo;
	unsigned char	Komi;
	unsigned char	RulePass;
	unsigned char	RuleScore;
	unsigned char	RuleSeki;
	unsigned char	RuleHandicap;
	unsigned char	RuleSuicide;
} GAME , OLD_GAME;
*/




/* public functions */

extern void Newgame(void);
extern void ClearScreen(void);
extern void DrawPiece(int x, int y, unsigned char color, Boolean last);
extern void count(int i, int j, int color);
extern void countlib(int m, int n, int color);
extern void endgame(void);

extern void eval(int color);
extern void examboard(int color);
extern int getij(char move[], int *i, int *j);
extern unsigned int findcolor(int i, int j);
extern int findnextmove(int m, int n, int *i, int *j, int *val, int minlib);
extern int findopen(int m, int n, int i[], int j[], int color, int minlib, int *ct);
extern int findpatn(int *i, int *j, int *val);
extern int findsaver(int *i, int *j, int *val);
extern int findwinner(int *i, int *j, int *val);
extern void genmove(int *i, int *j);
extern void getmove(char move[], int *i, int *j);
extern void initmark(void);
extern int matchpat(int m, int n, int *i, int *j, int *val);
extern int opening(int *i, int *j, int *cnd, int type);
extern int openregion(int i1, int j1, int i2, int j2);
extern void showboard(void);
extern void showinst(void);
extern void sethand(int i);
extern int suicide(int i, int j);

