/*
$Header: /home/koba/pilot/PilotGoJ/src/RCS/pilotgo.c,v 1.5 2000/03/13 12:28:31 koba Exp $
*/
/*		Japanized Pilot GO 
		Version 0.40a0
			by koba (BYH10475@nifty.ne.jp)
		based on Pilot Go 0.31 by Dr. Matthias von Davier 
*/
/*
                     Pilot GO frame program
                Version 0.22 last revised 9-17-97

               adapted for the USR Pilot & PalmPilot
                  9/10/97 by Matthias von Davier
*/

/*

                 GNUGO - the game of Go (Wei-Chi)
                Version 1.2   last revised 10-31-95
           Copyright (C) Free Software Foundation, Inc.
                      written by Man L. Li
                      modified by Wayne Iba
        modified by Frank Pursel <fpp%minor.UUCP@dragon.com>
                    documented by Bob Webber


This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation - version 2.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License in file COPYING for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

Please report any bug/fix, modification, suggestion to

           manli@cs.uh.edu

*/

/* SEND MODIFICATIONS of the PILOT version to:
 *
 *         vdavier@ipn.uni-kiel.de
 *
 *
 * Pilot Go
 *
 * by Matthias von Davier
 * september 1997
 */

/*
	Pilot Go J
		By Atsushi Kobayashi (BYH10475@nifty.ne.jp)

	Please send modification, bug/fix or comments to me.
*/

#pragma pack(2)
#include <Common.h>
#include <System/SysAll.h>
#include <UI/UIAll.h>
#include <Preferences.h>

#include "pigoid.h"
#include "pigoty.h"
#include "callback.h"


unsigned char ma[19][19]; /* working matrix for marking */
unsigned char ml[19][19]; /* working matrix for marking */
int lib;                  /* current stone liberty */
int mik, mjk;             /* location of computer stone captured */
int uik, ujk;             /* location of opponent stone captured */
int i,j;

int offset, width;
int prefStatus;

Word FrmRet;
GAME game;

char EndMess1[60] = "";
char EndMess2[40] = "\n My score:   ";
char EndMess3[40] = "\n Your score: ";
char SMytot[5] = "00000";
char SUtot[5]  = "00000";

int penX, penY, dummy;
int moved;

/*static DmOpenRef pgDB;*/

static int StartApplication(void);
static Err OpenDatabase(void);
static void SaveStatus(void);
static void EventLoop(void);
static void StopApplication(void);
static Boolean PilotGoMainEvent(EventPtr event);
static Boolean PilotGoPrefsEvent(EventPtr event);

static void SubNewGame(void) ;
static void SubAskFillNeutral(void) ;
static void SubEndGame0(void) ;
static void SubEndGame(void) ;

static void Swap(int *i, int *j);
static Boolean HumanMove(int penX, int penY);
static void KnightMoves(void);
static void RemoveDeadPiece(int i, int j ,unsigned char color );
static void StoneHenge(int penX, int penY, int MoveColor, int OtherColor);

static void SetHandicap(void);

static void SetPrefStatus(FormPtr form);


FieldPtr	fieldptr_text;   
// FieldPtr and DmOpenRef are defined in the PalmOS header files.
FieldPtr	fieldptr_hex;    
// See if you can find where they are defined.
DmOpenRef   PilotGoDB;

char            PilotGoDBName[] = "PilotGoJDB";


/********************************************************************/
static void Swap(int *i, int *j)
{
	int temp;
	temp = *i;
	*i = *j;
	*j = temp;
}

/********************************************************************/
static void StoneHenge(int penX, int penY, int MoveColor, int OtherColor)
{

	if (game.lastX != -1) 
		DrawPiece(game.lastX,game.lastY,
			game.p[game.lastX][game.lastY],FALSE);

	game.p[penX][penY] = MoveColor;
	examboard(OtherColor);

	DrawPiece(penX,penY,MoveColor,TRUE);
	game.lastX = penX;
	game.lastY = penY;
	
	return;
}

/********************************************************************/
static Boolean check_ko(int i,int j)
{
	if ( (game.BlackWhite != ((HUMAN << 2) | HUMAN)) ||
		i != game.uik || j != game.ujk) return FALSE;
	return TRUE;
}

/********************************************************************/
/*	Human	*/
static Boolean HumanMove(int penX, int penY)
{
	unsigned char undomask;

	if ((game.p[penX][penY] != EMPTY) || suicide(penX, penY) || check_ko(penX,penY)) {
		FrmCustomAlert(alertID_message,"","Illegal move!","");
		return FALSE;
	} else {
		/*	copy current board to Undo Buffer	*/
		switch (game.undocnt)	{
			case 0: undomask=0xfc; break;
			case 1: undomask=0xf3; break;
			case 2: undomask=0xcf; break;
			case 3: undomask=0x3f; break;
			default: undomask=0x00; break;
		}
	
		for (j=0;j<game.BoardSize;j++) 
			for (i=0;i<game.BoardSize;i++) 
				game.undo[i][j] = (game.undo[i][j]&undomask) |
					((game.p[i][j]&0x03) << (2*game.undocnt)) ;

		game.lastX_undo[game.undocnt] = game.lastX;
		game.lastY_undo[game.undocnt] = game.lastY;
		game.uk_undo[game.undocnt] = game.uk;
		game.uik_undo[game.undocnt] = game.uik;
		game.ujk_undo[game.undocnt] = game.ujk;
		game.mk_undo[game.undocnt] = game.mk;
		game.mik_undo[game.undocnt] = game.mik;
		game.mjk_undo[game.undocnt] = game.mjk;

		game.undocnt ++; if (game.undocnt>=UNDOMAX) game.undocnt = 0;

		/*		*/
		StoneHenge(penX,penY,game.umove,game.mymove);
		game.pass = 0;
		return TRUE;
	}
}


/********************************************************************/
/*	Computer 	*/
static void KnightMoves(void)
{
	int penX,penY;

	genmove(&penX,&penY);

	if (penX != -1)
		StoneHenge(penX,penY,game.mymove,game.umove);
	else
		if (game.RulePass == TRUE)
			FrmCustomAlert(alertID_message,"","I pass!","");
		else	{
			FrmCustomAlert(alertID_message,"","I want to pass. End Game!","");
			game.pass = 2;
		}

	return;
			
}

/********************************************************************/
DWord  PilotMain (Word cmd, Ptr cmdPBP, Word launchFlags)
{
	int error;

	if (cmd == sysAppLaunchCmdNormalLaunch)
	{

		error = StartApplication();	
		// Application start code
		if (error) return error;

		EventLoop();	
		// Event loop

		StopApplication ();	
		// Application stop code
	}
	return 0;
}



/********************************************************************/
static int StartApplication(void)
{
	int error;

	error = OpenDatabase();
	if (error) return error;
	FrmGotoForm(formID_PilotGo);
	return error;
}

/********************************************************************/
static void EventLoop(void)
{
	short err;
	int formID;
	FormPtr form;
	EventType event;

	do
	{

		EvtGetEvent(&event, 200);

		if (SysHandleEvent(&event)) continue;
		if (MenuHandleEvent((void *)0, &event, &err)) continue;

		if (event.eType == frmLoadEvent)
		{
			formID = event.data.frmLoad.formID;
			form = FrmInitForm(formID);
			FrmSetActiveForm(form);
			switch (formID)
			{
				/*	menu	*/
			case formID_PilotGo:
				FrmSetEventHandler(form, 
					(FormEventHandlerPtr) PilotGoMainEvent);
				break;
				/*	preference	*/
			case formID_Prefs:
				FrmSetEventHandler(form, 
					(FormEventHandlerPtr) PilotGoPrefsEvent);
				break;

			}
		}
		FrmDispatchEvent(&event);
	} while(event.eType != appStopEvent);
}

/********************************************************************/
static void StopApplication(void)
{
	FrmCloseAllForms();
	SaveStatus();
	/*
	  DmCloseDatabase(pgDB);
	*/
}

/************************************************/
/*	Event Handler for Main			*/
/************************************************/
static Boolean PilotGoMainEvent(EventPtr event)
{
	FormPtr   form;
	int       handled = 0;

	CALLBACK_PROLOGUE

	switch (event->eType)
	{

	/********** O P E N   E V E N T ********/
	case frmOpenEvent:
		form = FrmGetActiveForm();
		FrmDrawForm(form);

		if (prefStatus) SubNewGame();
		//ClearScreen();
		ShowBoard();


		handled = 1;
		break;

	/********** P E N   D O W N   E V E N T ********/
	case penDownEvent:
		dummy = (width / 2) - offset;
		penX = (event->screenX + dummy) / width;
		penX = MIN(18,MAX(0,penX));
		penY = (event->screenY + dummy) / width;
		penY = MIN(18,MAX(0,penY));
		switch (game.play)
		{
		case PLAY:
			if (game.BlackWhite == ((HUMAN<<2)|HUMAN)) {
				/*	Human vs Human	*/
				if (HumanMove(penX,penY)) {
					Swap(&game.mymove, &game.umove);
					Swap(&game.mk, &game.uk);
					Swap(&game.mik, &game.uik);
					Swap(&game.mjk, &game.ujk);
				}
			} else {
				if (HumanMove(penX,penY)) KnightMoves();
			}
			break;
		case ENDGAME:
			break;
		case FILLNEUTRAL:
			if (game.p[penX][penY] == EMPTY) {
				game.p[penX][penY] = game.fill;
				DrawPiece(penX,penY,game.fill,FALSE);
				if (game.fill == BLACK)
					game.fill = WHITE;
				else
					game.fill = BLACK;
			} else {
				FrmCustomAlert(alertID_message,"",
					"This intersection is not empty!","");
			}
			break;
		case REMOVEDEAD:
			if (game.p[penX][penY] != EMPTY)
				RemoveDeadPiece(penX,penY,game.p[penX][penY]);
			break;
		}
		handled = TRUE;
		break;

	/********** M E N U   E V E N T ********/
	case menuEvent:
		switch (event->data.menu.itemID)
		{
		/*	for Files	*/
		case menuitemID_prefs:
			FrmGotoForm(formID_Prefs);
			break;

		case menuitemID_newgame:
			if (FrmCustomAlert(alertID_confirm,
				"","New Game?","") == 0)
				SubNewGame();
			//ClearScreen();
			ShowBoard();
			handled=1;
			break;

		case menuitemID_loadgame:
			/* FrmCustomoAlert(alertID_message,"",
				"Not Yet implemented",""); */
			//break;

		case menuitemID_savegame:
			FrmCustomAlert(alertID_message," ",
					"Not Yet implemented"," ");
			/* if (FrmCustomAlert(alertID_confirm,
				"Save Game? ","Save game status?","") == 0)
			      { SaveStatus(); } */
			break;

		/*	for Play	*/
		case menuitemID_undo:
			/*	check play status	*/
			if (game.play != PLAY) break;	

			/*	check undo rule	*/
			if (game.RuleUndo ==FALSE) {
				FrmCustomAlert(alertID_message,"","You can't undo!","");
				break;
			}

			/*	goto previous undocnt	*/
			game.undocnt --; if (game.undocnt<0) game.undocnt = UNDOMAX-1;
			/*	copy previous board	*/
			for (j=0;j<game.BoardSize;j++) 
				for (i=0;i<game.BoardSize;i++) 
					game.p[i][j] =
						(game.undo[i][j] >> (2*game.undocnt)) 
							& 0x03;

			game.lastX = game.lastX_undo[game.undocnt];
			game.lastY = game.lastY_undo[game.undocnt];
			game.uk = game.uk_undo[game.undocnt];
			game.mk = game.mk_undo[game.undocnt];
			game.uik = game.uik_undo[game.undocnt];
			game.mik = game.mik_undo[game.undocnt];
			game.ujk = game.ujk_undo[game.undocnt];
			game.mjk = game.mjk_undo[game.undocnt];

			/*	if Human vs Human	*/
			if (game.BlackWhite == ((HUMAN<<2) | HUMAN)) {
				Swap(&game.mymove, &game.umove);
				Swap(&game.mk, &game.uk);
				Swap(&game.mik, &game.uik);
				Swap(&game.mjk, &game.ujk);
			}
			
				
			/*	Redraw prev board	*/
			//ClearScreen();
			ShowBoard();

			break;

		case menuitemID_pass:
			if(game.play != PLAY) break; 
			if(game.RulePass == FALSE) {
				FrmCustomAlert(alertID_message,"","You can't pass!","");
				break;
			}
			if (FrmCustomAlert(alertID_confirm," ",
				"Pass move?"," ") == 0) {
				++game.pass;
				if (game.pass<2) {
					if (game.BlackWhite == ((HUMAN<<2)|HUMAN)) {
						/*	Human vs Human	*/
						Swap(&game.mymove, &game.umove);
						Swap(&game.mk, &game.uk);
						Swap(&game.mik, &game.uik);
						Swap(&game.mjk, &game.ujk);
					} else {
						KnightMoves();
					}
				}
			}
			break;

		case menuitemID_end:
			if(game.play==PLAY)
				if (FrmCustomAlert(alertID_confirm," ",
						"End Game?"," ") == 0)
					game.pass = 2;
			break;

		case menuitemID_continue:
			switch (game.play)
			{
			case ENDGAME:
				break;

			case REMOVEDEAD:
				/* After remove dead pieces, fill in neutral */
				SubAskFillNeutral();
				break;
			case FILLNEUTRAL:
				SubEndGame();
				break;

			}
			break;

		/*	for HELP	*/
		case menuitemID_help:
			// FrmAlert(alertID_showinst);
			FrmHelp(HelpStr);
			break;

		case menuitemID_about:
			FrmAlert(alertID_about);
			break;

		default:
			break;
		}
	case nilEvent:
		handled = 1;
		break;
	default:
		break;
	}

	/* ENDGAME == TRUE */
	if ((game.pass > 1) && (game.play == PLAY))
		SubEndGame0();

	CALLBACK_EPILOGUE

	return handled;
}



/*******************************************************************************/
static void SetHandicap(void)
{
	int a,b,c;
	switch (game.BoardSize)	{
	case 9: a=2;b=4;c=6;break;
	case 13:a=3;b=6;c=9;break;
	default:a=3;b=9;c=15;break;
	}

	switch (game.handicap)	{
	case 9: game.p[c][b] = BLACK;
	case 8: game.p[a][b] = BLACK;
	case 7: game.p[b][c] = BLACK;
	case 6: game.p[b][a] = BLACK;
	case 5: game.p[b][b] = BLACK;
	case 4: game.p[c][c] = BLACK;
	case 3: game.p[a][a] = BLACK;
	case 2: game.p[c][a] = BLACK;
	case 1: game.p[a][c] = BLACK;
	default:break;
	}
	return;
}


/*******************************************************************************/
static void SubNewGame(void) 
{
	/*	Clear preference	*/
	prefStatus = FALSE;

	/*	Black 	White	*/
	if (game.BlackWhite != ((HUMAN<<2)|HUMAN)){
		/*	Human vs Computer	*/
		if ((game.BlackWhite&0x03) == HUMAN)	{
			game.mymove = WHITE;/* computer white */
			game.umove = BLACK; /* human black */
		} else {
			game.mymove = BLACK;/* computer black */
			game.umove = WHITE; /* human white */
		}
	} else {
		/*	Human vs Human	*/
		game.mymove = WHITE;  /* human white */
		game.umove = BLACK; /* human black */
	}

	Newgame();
	SaveStatus();

	if (game.handicap > 0) SetHandicap();

	/*	if Palm is black	*/
	if (game.mymove == BLACK) KnightMoves();

	return;
}

/*******************************************************************************/
static void SubAskFillNeutral(void) 
{
	if(FrmCustomAlert(alertID_confirm,
		"Next, you need to fill in pieces (black and white) in all neutral territories. Tap on the intersections ",
		"and your and my color will be filled in alternately, choose 'Continue' when finished.",
		"\n\n Are the neutral areas?")==0)
	{
		game.play = FILLNEUTRAL;
		game.fill = BLACK;
		return;
	}
	SubEndGame();	
	return ;
}

/*******************************************************************************/
static void SubEndGame0(void)
{

	// game.play = REMOVEDEAD;
	FrmCustomAlert(alertID_message,
	    "To count score, we need the following steps: First, I need you to remove all ",
	    "dead pieces on the board. Second, I need you to fill in neutral territories ",
	    "with pieces. Last, I will fill in all pieces and announce the winner.");

	/* remove dead pieces */

	game.pass = 0;

	if (FrmCustomAlert(alertID_confirm,
	    "First, you should enter the dead pieces (black and white) to be removed. ",
	    "Choose 'Continue' in the Options menu when finished.\n\n",
	    "Are there dead pieces?")==0) {
		game.play = REMOVEDEAD;
	} else {
		game.play = FILLNEUTRAL;
		SubAskFillNeutral();
	}

}

/*******************************************************************************/
static void SubEndGame(void) 
{	
	int mtot,utot;
	int mme,ume;		/* number of eyes	*/

	/* set empty to side they belong to */
	mme=ume=0;
	for (i = 0; i < game.BoardSize; i++)
		for (j = 0; j < game.BoardSize; j++)
			if (game.p[i][j] == EMPTY) {
				if((game.p[i][j] = findcolor(i, j)) == game.mymove)
					mme++;
				else
					ume++;

				DrawPiece(i,j,game.p[i][j],FALSE);
			}

	/*	Scoring Rule	*/
	//	Japanese style  Teritory Rule
	utot = ume - game.uk;
	mtot = mme - game.mk;


	/*	Adding Komi	*/
	if (game.mymove == WHITE) {
		mtot = mtot * 2 + game.Komi;
		utot <<= 1;
	} else {
		mtot <<= 1;
		utot = utot *2 + game.Komi;
	}

	if (game.BlackWhite != ((HUMAN << 2) | HUMAN)) {
		/*	Palm vs Human	*/
		if (utot > mtot)
			StrCopy(EndMess1,"Can't believe it, you win!");
		else
			StrCopy(EndMess1,"I win! (pretty easy)");

		StrCopy(EndMess2,"\nMy score :");
		StrIToA(SMytot,mtot/2);
		StrCat(EndMess2, SMytot);
		if (game.mymove == WHITE) StrCat(EndMess2, ".5");

		StrCopy(EndMess3,"\nYour score:");
		StrIToA(SUtot,utot/2);
		StrCat(EndMess3, SUtot);
		if (game.umove == WHITE) StrCat(EndMess3, ".5");
	} else {
		/*	Human vs Human	*/
		/*	my:black	*/
		/*	u:white		*/
		if (game.mymove == WHITE)	Swap(&utot,&mtot);

		if (utot > mtot)
			StrCopy(EndMess1,"White wins!");
		else
			StrCopy(EndMess1,"Black wins!");

		StrCopy(EndMess2,"\nBlack score :");
		StrIToA(SMytot,mtot/2);
		StrCat(EndMess2, SMytot);

		StrCopy(EndMess3,"\nWhite score:");
		StrIToA(SUtot,utot/2);
		StrCat(EndMess3, SUtot);
		StrCat(EndMess3, ".5");
	}

	/*	Display Score	*/
	FrmCustomAlert(alertID_message,EndMess1, EndMess2,EndMess3 );

	return;
}

/*******************************************************************************/

/*
 * Database (here: game status information) handling routines.
 */

static Err OpenDatabase(void)
{
	SWord	prefret;
	Word	prefsize;

	prefret = PrefGetAppPreferencesV10(CREATERID,PREFVERSION,&game,sizeof(GAME));

	if (prefret == FALSE )/*&& 
	    PrefGetAppPreferencesV10(CREATERID,PREFVERSION-1,&game,sizeof(OLD_GAME)) == false)*/ {

		/*	NO PREFERENCES	*/
		/* init game.structure with defaults */
		/*	Default	Setting	*/
		game.Version = 0x40;
		game.UndoDefault = FALSE;
		game.Komi = game.KomiDefault = 11;
		game.RulePass = game.RulePassDefault = FALSE;
		game.RuleUndo = TRUE;
		game.RuleScoreDefault = TRUE;
		game.RuleSeki = game.RuleSekiDefault = FALSE;
		game.RuleHandicap = game.RuleHandicapDefault = TRUE;
		game.RuleSuicide = game.RuleSuicideDefault = TRUE;

		game.umove     = BLACK;
		game.mymove    = WHITE;
		game.BoardSize = 19;
		game.mycount = 0;
		game.undocnt = 0;

		game.BlackWhite = (PALM<<2) | HUMAN;
		prefStatus = FALSE;

		Newgame();


		prefsize = sizeof (GAME);

		/*	PrefSetAppPreferencesV10(CREATERID,0,VERSION,&game, prefsize,TRUE);
			*/

	} else {


	}

	return 0;

}
	

/**********************************************
 * Save game status information.
 **********************************************/
static void SaveStatus(void)
{
	Word	prefsize;
	prefsize = sizeof (GAME);
	PrefSetAppPreferencesV10(CREATERID,PREFVERSION,&game, sizeof(GAME));
	
}
	
/***********************************************/
static void  RemoveDeadPiece(int i, int j ,unsigned char color )
{
	
	if (game.p[i][j] == game.mymove) game.mk++;
	if (game.p[i][j] == game.umove) game.uk++;
      
	game.p[i][j] = EMPTY;
	DrawPiece(i,j,EMPTY,FALSE);
     
	// check i-1
	if (i>=0 && game.p[i-1][j] == color)
		RemoveDeadPiece(i-1,j,color);
	        
	// check i+1
	if (i<game.BoardSize  && game.p[i+1][j] == color)
      		RemoveDeadPiece(i+1,j,color);
	
	// check j-1
	if (j>=0 && game.p[i][j-1] == color)
		RemoveDeadPiece(i,j-1,color);
	        
	// check j+1
	if (j<game.BoardSize && game.p[i][j+1] == color)
		RemoveDeadPiece(i,j+1,color);
	       
	       
	return ;
	             
	
}


/*	variables for Preferences	*/
static ControlPtr ctlSize9,ctlSize13,ctlSize19;
static ControlPtr ctlBlHuman,ctlBlComp,ctlWhHuman,ctlWhComp;
static ControlPtr ctlHandi0,ctlHandi2, ctlHandi3, ctlHandi4, ctlHandi5,
		ctlHandi6, ctlHandi7, ctlHandi8, ctlHandi9;
static ControlPtr ctlKomi;
static ControlPtr ctlSGFEnable;
static ControlPtr ctlPassEnable;
static ControlPtr ctlUndoEnable;

static int	prefSize,prefBlack,prefWhite,prefHandicap,prefKomi;
static int	prefStoreSGF;

/*****************************************************/
static void SetPrefStatus(FormPtr form)
{
	/*	Board Size	*/
	ctlSize9 = FrmGetObjectPtr(form,FrmGetObjectIndex(form,pbID_Size9));
	ctlSize13 = FrmGetObjectPtr(form,FrmGetObjectIndex(form,pbID_Size13));
	ctlSize19 = FrmGetObjectPtr(form,FrmGetObjectIndex(form,pbID_Size19));
	switch(prefSize = game.BoardSize) {
		case 9: CtlSetValue(ctlSize9,true); break;
		case 13: CtlSetValue(ctlSize13,true); break;
		default: CtlSetValue(ctlSize19,true); break;
	}

	/*	BlackWhite	*/
	ctlBlHuman = FrmGetObjectPtr(form,FrmGetObjectIndex(form,pbID_BlHuman));
	ctlBlComp = FrmGetObjectPtr(form,FrmGetObjectIndex(form,pbID_BlComp));
	ctlWhHuman = FrmGetObjectPtr(form,FrmGetObjectIndex(form,pbID_WhHuman));
	ctlWhComp = FrmGetObjectPtr(form,FrmGetObjectIndex(form,pbID_WhComp));
	/*	black	*/
	if ((game.BlackWhite & 0x003)== HUMAN)	{
		prefBlack = HUMAN;
		CtlSetValue(ctlBlHuman,true); 
	} else {
		prefBlack = PALM;
		CtlSetValue(ctlBlComp,true); 
	}
	/*	white	*/
	if (((game.BlackWhite>>2)& 0x003) == HUMAN) {
		prefWhite = HUMAN;
		CtlSetValue(ctlWhHuman,true); 
	} else {
		prefWhite = PALM;
		CtlSetValue(ctlWhComp,true); 
	}
		
	/*	Handicap	*/
	ctlHandi0 = FrmGetObjectPtr(form,FrmGetObjectIndex(form,pbID_Handi0));
	ctlHandi2 = FrmGetObjectPtr(form,FrmGetObjectIndex(form,pbID_Handi2));
	ctlHandi3 = FrmGetObjectPtr(form,FrmGetObjectIndex(form,pbID_Handi3));
	ctlHandi4 = FrmGetObjectPtr(form,FrmGetObjectIndex(form,pbID_Handi4));
	ctlHandi5 = FrmGetObjectPtr(form,FrmGetObjectIndex(form,pbID_Handi5));
	ctlHandi6 = FrmGetObjectPtr(form,FrmGetObjectIndex(form,pbID_Handi6));
	ctlHandi7 = FrmGetObjectPtr(form,FrmGetObjectIndex(form,pbID_Handi7));
	ctlHandi8 = FrmGetObjectPtr(form,FrmGetObjectIndex(form,pbID_Handi8));
	ctlHandi9 = FrmGetObjectPtr(form,FrmGetObjectIndex(form,pbID_Handi9));
	switch (prefHandicap = game.handicap) {
		case 0: CtlSetValue(ctlHandi0,true);break;
		case 2: CtlSetValue(ctlHandi2,true);break;
		case 3: CtlSetValue(ctlHandi3,true);break;
		case 4: CtlSetValue(ctlHandi4,true);break;
		case 5: CtlSetValue(ctlHandi5,true);break;
		case 6: CtlSetValue(ctlHandi6,true);break;
		case 7: CtlSetValue(ctlHandi7,true);break;
		case 8: CtlSetValue(ctlHandi8,true);break;
		case 9: CtlSetValue(ctlHandi9,true);break;
	}

	/*	Pass	*/
	ctlPassEnable = FrmGetObjectPtr(form,FrmGetObjectIndex(form,cbID_PassEnable));
	CtlSetValue(ctlPassEnable,game.RulePass);
	/*	Undo	*/
	ctlUndoEnable = FrmGetObjectPtr(form,FrmGetObjectIndex(form,cbID_UndoEnable));
	CtlSetValue(ctlUndoEnable,game.RuleUndo);

	/*	Not Implemented	*/
	ctlKomi = FrmGetObjectPtr(form,FrmGetObjectIndex(form,liID_Komi));
	ctlSGFEnable = FrmGetObjectPtr(form,FrmGetObjectIndex(form,cbID_SGFEnable));
	
	return;
}


/************************************************/
/*	Event Handler for Preference		*/
/************************************************/
static Boolean PilotGoPrefsEvent(EventPtr event)
{
	FormPtr	form;
	int	handled = 0;

	CALLBACK_PROLOGUE

	switch (event->eType) {
	case frmOpenEvent:
		form = FrmGetActiveForm();
		SetPrefStatus(form);
		FrmDrawForm(form);
		handled = 1;
		break;
	case ctlSelectEvent:
		switch (event->data.ctlSelect.controlID) {
		/*	Board Size	*/
		case pbID_Size9: prefSize = 9; break;
		case pbID_Size13: prefSize = 13; break;
		case pbID_Size19: prefSize = 19; break;
		/*	Black White	*/
		case pbID_BlHuman: prefBlack = HUMAN; break;
		case pbID_BlComp: 
			prefBlack = PALM; prefWhite = HUMAN; 
			CtlSetValue(ctlWhHuman,true);
			CtlSetValue(ctlWhComp,false);
			break;
		case pbID_WhHuman: prefWhite = HUMAN; break;
		case pbID_WhComp: 
			prefWhite = PALM; prefBlack = HUMAN; 
			CtlSetValue(ctlBlHuman,true);
			CtlSetValue(ctlBlComp,false);
			break;
		/*	Handicap	*/
		case pbID_Handi0: prefHandicap = 0; break;
		case pbID_Handi2: prefHandicap = 2; break;
		case pbID_Handi3: prefHandicap = 3; break;
		case pbID_Handi4: prefHandicap = 4; break;
		case pbID_Handi5: prefHandicap = 5; break;
		case pbID_Handi6: prefHandicap = 6; break;
		case pbID_Handi7: prefHandicap = 7; break;
		case pbID_Handi8: prefHandicap = 8; break;
		case pbID_Handi9: prefHandicap = 9; break;
		/*	PassRule	*/
		case cbID_PassEnable: break;
		/*	UndoRule	*/
		case cbID_UndoEnable: break;
		
		/*	not inplemented	*/
		case liID_Komi: break;
		case cbID_SGFEnable: CtlSetValue(ctlSGFEnable,false);break;

		/*	OK!	*/
		case pbID_New:
			game.BoardSize = prefSize;
			game.BlackWhite = (prefWhite<<2) | prefBlack;
			game.handicap = prefHandicap;
			game.RulePass = CtlGetValue(ctlPassEnable);
			game.RuleUndo = CtlGetValue(ctlUndoEnable);
			prefStatus=true;
			FrmGotoForm(formID_PilotGo);
			handled = 1;
			break;

		/*	Canceled	*/
		case pbID_Cancel:
			prefStatus=false;
			FrmGotoForm(formID_PilotGo);
			handled = 1;
			break;
		}
		break;
	case nilEvent:
		handled = 1;
		break;
	default:
		break;
	}

	CALLBACK_EPILOGUE

	return handled;
}


